package sshoneypot

import (
	"fmt"
	"log"
)

// A simple high changeable logging interface
type Logging struct {
	enable bool
}

func (l *Logging) Info(content string) {
	if l.enable {
		log.Println(content)
	}
}

func (l *Logging) Infof(format string, args... interface{}) {
	log.Printf(fmt.Sprintf(format, args))
}

func (l *Logging) Warn(content string) {
	if l.enable {
		log.Println(content)
	}
}

func (l *Logging) Warnf(format string, args... interface{}) {
	log.Printf(fmt.Sprintf(format, args))
}

func (l *Logging) Error(content string) {
	if l.enable {
		log.Println(content)
	}
}

func (l *Logging) Errorf(format string, args... interface{}) {
	l.Error(fmt.Sprintf(format, args))
}
